/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Osoyoo W5100 web server lesson 10
 * Send front obstacle distance to web browser
 * tutorial url: https://osoyoo.com/?p=10009
 */

#include <Ethernet.h>
#define Echo_PIN    7 // Ultrasonic Echo pin connect to D7
#define Trig_PIN    8  // Ultrasonic Trig pin connect to D8

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; //physical mac address 
//IPAddress ip(192.168.0.109); uncomment this line if you want define static IP instead of dynamic IP from DHCP server
EthernetServer server(80); //server port
String readString; 

void setup(){
  Serial.begin(9600);
 
  Serial.println("connect DHCP server");
  //start Ethernet 
  Ethernet.begin(mac); // if you defined static ip in line 28, change this line to   Ethernet.begin(mac,ip); 
  server.begin(); 
  Serial.print("Please use your browser to visit http://");
  Serial.println(Ethernet.localIP());
 
}

void loop(){ 
  // Create a client connection 
  EthernetClient client = server.available(); 
  if (client) { 
    while (client.connected()) { 
      if (client.available()) { 
        char c = client.read();
        //read char by char HTTP request 
        while (readString.length() < 100 && c != 0x0D  ) {
        //store characters to string 
        readString += c; 
        c = client.read();
      }
     // Serial.println(readString);
 
   
      String msg="HTTP/1.1 200 OK\n\rContent-Type: text/html\n\r\n\r";
      msg +="<HTML><meta http-equiv=\"refresh\" content=\"5\"><BODY><H1 style=\"color:green;\">Arduino IoT Lesson 10</H1><br>";
      msg +=  "Obstacle distance: " ;
      msg += watch();

      msg += " cm</p></BODY></HTML>";
      client.println(msg);
      delay(10); 
      //stopping client 
      client.stop();
      //clearing string for next read 
      readString="";
    } 
  } 
 } 
}
/*detection of ultrasonic distance*/
int watch(){
  long echo_distance;
  digitalWrite(Trig_PIN,LOW);
  delayMicroseconds(5);                                                                              
  digitalWrite(Trig_PIN,HIGH);
  delayMicroseconds(15);
  digitalWrite(Trig_PIN,LOW);
  echo_distance=pulseIn(Echo_PIN,HIGH);
  echo_distance=echo_distance*0.01657; //how far away is the object in cm
  //Serial.println((int)echo_distance);
  return round(echo_distance);
}
